poj3126 Prime Path

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033 
1733 
3733 
3739 
3779 
8779 
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0

解題思路:
題意就是將一個數轉換成另一個數,轉換的過程中還要保證是素數,這個也是bfs能解決的,分別對於個位十位百位千位都處理,要注意其實偶數一定不是素數的,所以對於個位可以用2的幅度去加,而千位是沒有0的,而對於素數的判斷,除了小於sqrt()之外,還有素數篩,比如2的倍數都不是素數,那麼就把2的倍數都篩掉,這樣一直下去,會很快

代碼:
#include<iostream>
#include<queue>
#include<cstring>
#include<cmath>
using namespace std;
int beginn,endd;
int vis[10005];
struct node
{
    int x;
    int step;
};

bool ok(int a)
{
    if(a==2||a==3)
        return true;
    if(a==1||a==0)
        return false;
    for(int i = 2;i<=(int)sqrt(a);i++)
    {
        if(a%i==0)
            return false;
    }
    return true;
}

int bfs(int now)
{
    node help;
    node help1;
    help.x = now;
    help.step = 0;
    queue<node> q;
    q.push(help);
    vis[now] = 1;
    while(!q.empty())
    {
       // cout<<"here"<<endl;
        help = q.front();
        q.pop();
        if(help.x==endd)
        {
           // cout<<"here"<<endl;
            return help.step;
        }

        for(int i = 1;i<=9;i+=2)
        {
            int s = help.x/10*10+i;
           // cout<<"gewei "<<s<<endl;
            help1.x = s;
            help1.step = help.step+1;
            if(!vis[help1.x]&&ok(help1.x))
            {
                q.push(help1);
                vis[help1.x] = 1;
            }
        }
        for(int i = 0;i<=9;i++)
        {
            int s = help.x/100*100+i*10+help.x%10;
            //cout<<"baiwei "<<s<<endl;
            help1.x = s;
            help1.step = help.step+1;
            if(!vis[help1.x]&&ok(help1.x))
            {
                q.push(help1);
                vis[help1.x] = 1;
            }
        }
        for(int i = 0;i<=9;i++)
        {
            int s = help.x/1000*1000+i*100+help.x%100;
            //cout<<"qianwei "<<s<<endl;
            help1.x = s;
            help1.step = help.step+1;
            if(!vis[help1.x]&&ok(help1.x))
            {
                q.push(help1);
                vis[help1.x] = 1;
            }
        }
        for(int i = 1;i<=9;i++)
        {
            int s = i*1000+help.x%1000;
            //
            help1.x = s;
            help1.step = help.step+1;
            if(!vis[help1.x]&&ok(help1.x))
            {
              //  cout<<"hisudfh"<<endl;
                q.push(help1);
                vis[help1.x] = 1;
            }
        }
    }
    return -1;
}

int main()
{
    int t;
    cin>>t;
    while(t--)
    {
        memset(vis,0,sizeof(vis));
        cin>>beginn>>endd;
        int re = bfs(beginn);
        cout<<re<<endl;
    }
}


發佈了79 篇原創文章 · 獲贊 1 · 訪問量 8909
發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章